Index: code/branches/HUD_HS16/data/overlays/SOBHUD.oxo
===================================================================
--- code/branches/HUD_HS16/data/overlays/SOBHUD.oxo	(revision 11502)
+++ code/branches/HUD_HS16/data/overlays/SOBHUD.oxo	(revision 11502)
@@ -0,0 +1,123 @@
+<Template name="spectatorhud">
+  <OverlayGroup name = "spectatorhud" scale = "1, 1">
+  </OverlayGroup>
+</Template>
+
+<Template name="SOBHUD">
+  <OverlayGroup name="SOBHUD" scale = "1, 1">
+  
+    <OverlayText
+     position  = "0.02, 0.02"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.04
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "left"
+     caption   = "O R X O\n"
+    />
+    <SOBHUDInfo
+     position  = "0.02, 0.06"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.045
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "left"
+     type      = "Points"
+     
+    />
+
+
+
+    <SOBHUDInfo
+     position  = "0.22, 0.06"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.045
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "left"
+     type      = "Coins"
+     
+    />
+
+
+
+    <OverlayText
+     position  = "0.75, 0.02"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.04
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "center"
+     caption   = "WORLD\n1-1"
+    />
+
+
+
+
+
+
+    <OverlayText
+     position  = "0.98, 0.02"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.04
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "right"
+     caption   = "TIME\n"
+    />
+    <SOBHUDInfo
+     position  = "0.98, 0.06"
+     pickpoint = "0.0, 0.0"
+     font      = "ShareTechMono"
+     textsize  = 0.04
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "right"
+     type      = "Time"
+  
+    />
+
+    
+
+    <SOBHUDInfo
+     position = "0.55,0.5"
+     pickpoint = "0.5, 0.5"
+     textposition  = "0.5, 0.5"
+     textpickpoint = "0.5, 0.5"
+     font      = "ShareTechMono"
+     textsize  = 0.07
+     colour    = "1.0, 1.0, 1.0, 1.0"
+     align     = "center"
+     type      = "Info"
+     
+    />
+   
+
+    
+  </OverlayGroup>
+</Template>
+
+
+<Template name="spaceshiphud">
+  <OverlayGroup name = "spaceshiphud" scale = "1, 1">
+    <HUDHealthBar
+     name              = "HealthBar1"
+     background        = "Orxonox/HealthBarBackground"
+     size              = "0.35, 0.0875"
+     position          = "0.0 , 0.9 "
+     pickpoint         = "0, 1"
+     bartexture        = "healthbar_bar.png"
+     textfont          = "VeraMono"
+     textusebarcolour  = true
+     textscale          = 0.4
+     textoffset        = "0.325, -0.825"
+     textpickpoint     = "0, 0"
+     textalign         = "right"
+     correctaspect     = true
+     iconmaterial      = "Orxonox/BarIconHealth"
+    >
+      <BarColour position = 0.0 colour = "0.7,0.2,0.2" />
+      <BarColour position = 0.5 colour = "0.7,0.7,0.2" />
+      <BarColour position = 1.0 colour = "0.2,0.7,0.2" />
+    </HUDHealthBar>
+ </OverlayGroup>
+</Template>
Index: code/branches/HUD_HS16/data/overlays/StoryModeHUD.oxo
===================================================================
--- code/branches/HUD_HS16/data/overlays/StoryModeHUD.oxo	(revision 11502)
+++ code/branches/HUD_HS16/data/overlays/StoryModeHUD.oxo	(revision 11502)
@@ -0,0 +1,14 @@
+
+<Template name="StoryModeMap">
+  <OverlayGroup name = "spaceshiphud" scale = "1, 1">
+    <Map />
+
+
+     <GUIOverlay
+      name = "CampaignMenu"
+      guiname = "CampaignMenu"
+      visible = "true"
+    />
+
+  </OverlayGroup>
+</Template>
Index: code/branches/HUD_HS16/src/modules/CMakeLists.txt
===================================================================
--- code/branches/HUD_HS16/src/modules/CMakeLists.txt	(revision 11501)
+++ code/branches/HUD_HS16/src/modules/CMakeLists.txt	(revision 11502)
@@ -26,4 +26,5 @@
 ################ Sub Directories ################
 
+ADD_SUBDIRECTORY(dialogue)
 ADD_SUBDIRECTORY(designtools)
 ADD_SUBDIRECTORY(gametypes)
@@ -44,2 +45,3 @@
 ADD_SUBDIRECTORY(dodgerace)
 ADD_SUBDIRECTORY(hover)
+ADD_SUBDIRECTORY(superorxobros)
Index: code/branches/HUD_HS16/src/modules/dialogue/CMakeLists.txt
===================================================================
--- code/branches/HUD_HS16/src/modules/dialogue/CMakeLists.txt	(revision 11502)
+++ code/branches/HUD_HS16/src/modules/dialogue/CMakeLists.txt	(revision 11502)
@@ -0,0 +1,15 @@
+SET_SOURCE_FILES(DIALOGUE_SRC_FILES
+  DialogueManager.cc
+  NextQuestion.cc
+ 
+)
+
+ORXONOX_ADD_LIBRARY(dialogue
+  MODULE
+  FIND_HEADER_FILES
+   TOLUA_FILES
+    DialogueManager.h
+  LINK_LIBRARIES
+    orxonox
+  SOURCE_FILES ${DIALOGUE_SRC_FILES}
+)
Index: code/branches/HUD_HS16/src/modules/dialogue/DialogueManager.cc
===================================================================
--- code/branches/HUD_HS16/src/modules/dialogue/DialogueManager.cc	(revision 11502)
+++ code/branches/HUD_HS16/src/modules/dialogue/DialogueManager.cc	(revision 11502)
@@ -0,0 +1,92 @@
+#include "core/CoreIncludes.h"
+#include "core/LuaState.h"
+#include "core/GUIManager.h"
+#include "core/class/Identifier.h"
+#include "core/singleton/ScopedSingletonIncludes.h"
+#include "network/Host.h"
+#include "network/NetworkFunctionIncludes.h"
+#include "DialogueManager.h"
+#include <vector>
+#include <string>
+#include "core/XMLPort.h"
+#include "NextQuestion.h"
+
+
+
+namespace orxonox {
+	ManageScopedSingleton(DialogueManager, ScopeID::ROOT, false);
+	
+
+	
+	DialogueManager::DialogueManager(){}
+	
+
+	
+    
+
+	void DialogueManager::registerquestion(NextQuestion* nq){
+		if(allQuestions.size()==0) {
+			orxout(internal_info) << "At least one NextQuestion has to be set." << endl;
+		} 
+		allQuestions.push_back(nq);
+			orxout(internal_info) << "qsize " << allQuestions.size();
+
+	}	
+
+    void DialogueManager::setquestion(std::string q){
+		question=q;
+		
+	}
+	void DialogueManager::setCurrentQuestion(NextQuestion* nq){
+		currentQuestion=nq;
+		
+	}
+
+	std::string DialogueManager::getquestion(void){
+		return question;
+	}
+
+	void DialogueManager::setanswers1(std::string a1){
+		this->a1=a1;
+				}
+
+	void DialogueManager::setanswers2(std::string a2){
+		this->a2=a2;
+				}
+
+	
+
+	std::string DialogueManager::getanswers1(void){
+		return a1;
+	}
+
+	std::string DialogueManager::getanswers2(void){
+		return a2;
+	}
+
+	void DialogueManager::a1clicked(void){
+		
+		currentQuestion = currentQuestion->possibleQuestions[0];
+		update(currentQuestion);
+
+		
+	}
+	void DialogueManager::a2clicked(void){
+		
+		currentQuestion = currentQuestion->possibleQuestions[1];
+		update(currentQuestion);
+	}
+
+	 void DialogueManager::update(NextQuestion* nq){
+	 	this->setquestion(nq->getquestion());
+	 	this->setanswers1(nq->getanswers1());
+	 	this->setanswers2(nq->getanswers2());
+	 }
+
+	bool DialogueManager::theEnd(){
+	if((currentQuestion->possibleQuestions).empty()) {
+		return true;}
+	else return false;
+	}
+
+}
Index: code/branches/HUD_HS16/src/modules/dialogue/DialogueManager.h
===================================================================
--- code/branches/HUD_HS16/src/modules/dialogue/DialogueManager.h	(revision 11502)
+++ code/branches/HUD_HS16/src/modules/dialogue/DialogueManager.h	(revision 11502)
@@ -0,0 +1,74 @@
+#ifndef _DialogueManager_H__
+#define _DialogueManager_H__
+
+#include "core/CoreIncludes.h"
+#include "core/LuaState.h"
+#include "core/GUIManager.h"
+#include "core/class/Identifier.h"
+#include "core/singleton/ScopedSingletonIncludes.h"
+#include "network/Host.h"
+#include "network/NetworkFunctionIncludes.h"
+#include "util/Singleton.h"
+#include <string>
+#include <vector>
+#include "core/config/Configurable.h"
+#include "core/XMLPort.h"
+#include "core/EventIncludes.h"
+#include "DialoguePrereqs.h"
+#include "NextQuestion.h"
+
+
+
+
+namespace orxonox //tolua_export
+
+{//tolua_export
+	class _OrxonoxExport DialogueManager //tolua_export
+	: public Singleton<DialogueManager>
+	{//tolua_export
+		friend class Singleton<DialogueManager>;
+	
+		public:
+		
+		DialogueManager(); 
+		
+
+		static DialogueManager& getInstance() { return Singleton<DialogueManager>::getInstance(); } //tolua_export
+		
+
+		void setquestion(std::string question); //tolua_export
+		std::string getquestion(void); //tolua_export
+		
+		
+		void setanswers1(std::string a1); //tolua_export
+		std::string getanswers1(void); //tolua_export
+		
+		void setanswers2(std::string a2); //tolua_export
+		std::string getanswers2(void); //tolua_export
+		
+		void setCurrentQuestion(NextQuestion* q);
+
+		//Sets the current Question to the question corresponding to the first/second answer  
+		void a1clicked(void); //tolua_export
+		void a2clicked(void); //tolua_export
+		
+		//Checks whether there are any more Questions to come
+		bool theEnd(); //tolua_export 
+
+		//Sets question and a1, a2 for new currentQuestion
+		void update(NextQuestion* nq);
+
+		//Is executed whenever a NextQuestion is created and pushes all NextQuestion into the allQuestion vector.
+		void registerquestion(NextQuestion* nq);
+
+private:
+	NextQuestion* currentQuestion; //The Question which is currently displayed
+	std::vector<NextQuestion*> allQuestions;
+	std::string a1; //answer on first button
+	std::string a2; //answer on second button
+	std::string question;
+	static DialogueManager* singletonPtr_s;
+
+	};//tolua_export
+}//tolua_export
+#endif
Index: code/branches/HUD_HS16/src/modules/dialogue/DialoguePrereqs.h
===================================================================
--- code/branches/HUD_HS16/src/modules/dialogue/DialoguePrereqs.h	(revision 11502)
+++ code/branches/HUD_HS16/src/modules/dialogue/DialoguePrereqs.h	(revision 11502)
@@ -0,0 +1,76 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Damian 'Mozork' Frick
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Shared library macros, enums, constants and forward declarations for the questsystem module
+*/
+
+#ifndef _DialoguePrereqs_H__
+#define _DialoguePrereqs_H__
+
+#include "OrxonoxConfig.h"
+#include "OrxonoxPrereqs.h"
+
+//-----------------------------------------------------------------------
+// Shared library settings
+//-----------------------------------------------------------------------
+
+#if defined(ORXONOX_PLATFORM_WINDOWS) && !defined(Dialogue_STATIC_BUILD)
+#  ifdef Dialogue_SHARED_BUILD
+#    define _DialogueExport __declspec(dllexport)
+#  else
+#    if defined( __MINGW32__ )
+#      define _DialogueExport
+#    else
+#      define _DialogueExport __declspec(dllimport)
+#    endif
+#  endif
+#  define _DialoguePrivate
+#elif defined (ORXONOX_GCC_VISIBILITY)
+#  define _DialogueExport  __attribute__ ((visibility("default")))
+#  define _DialoguePrivate __attribute__ ((visibility("hidden")))
+#else
+#  define _DialogueExport
+#  define _DialoguePrivate
+#endif
+
+//-----------------------------------------------------------------------
+// Forward declarations
+//-----------------------------------------------------------------------
+
+namespace orxonox
+{
+
+    class DialogueManager;
+    class NextQuestion;
+   
+}
+
+#endif /* _DialoguePrereqs_H__ */
Index: code/branches/HUD_HS16/src/modules/dialogue/NextQuestion.cc
===================================================================
--- code/branches/HUD_HS16/src/modules/dialogue/NextQuestion.cc	(revision 11502)
+++ code/branches/HUD_HS16/src/modules/dialogue/NextQuestion.cc	(revision 11502)
@@ -0,0 +1,111 @@
+//#include <vector>
+#include <string>
+#include "core/CoreIncludes.h"
+#include "core/GUIManager.h"
+#include "overlays/OrxonoxOverlay.h"
+
+
+#include "NextQuestion.h"
+#include "core/XMLPort.h"
+#include "DialogueManager.h"
+
+namespace orxonox{
+
+	RegisterClass(NextQuestion);
+
+	NextQuestion::NextQuestion(Context* context) : BaseObject(context)
+    {
+        RegisterObject(NextQuestion);
+
+        DialogueManager& m = DialogueManager::getInstance();
+        m.registerquestion(this);
+       
+        
+    }
+
+	void NextQuestion::setquestion(std::string question){
+		this->question=question;
+	}
+
+	std::string NextQuestion::getquestion(void){
+		return question;
+	}
+
+	
+	bool NextQuestion::addposQuestion(NextQuestion* nq){
+		
+		possibleQuestions.push_back(nq);
+		return true;
+	}
+
+	const NextQuestion* NextQuestion::getposQuestion(unsigned int i) const
+    {
+        for (NextQuestion* effect : this->possibleQuestions)
+        {
+            if(i == 0)
+               return effect;
+            i--;
+        }
+        return nullptr;
+         }
+	
+	
+	void NextQuestion::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(NextQuestion, XMLPort, xmlelement, mode);
+
+        XMLPortParam(NextQuestion, "question", setquestion, getquestion, xmlelement, mode);
+        XMLPortParam(NextQuestion, "a1", setanswers1, getanswers1, xmlelement, mode);
+        XMLPortParam(NextQuestion, "a2", setanswers2, getanswers2, xmlelement, mode);
+        XMLPortObject(NextQuestion, NextQuestion, "possibleQuestions", addposQuestion, getposQuestion, xmlelement, mode);
+       
+    }
+	bool NextQuestion::execute(bool bTriggered, BaseObject* trigger)
+    {  
+        
+    	DialogueManager& m = DialogueManager::getInstance();
+        	
+        m.setquestion(question);
+        m.setCurrentQuestion(this);
+        m.setanswers1(a1);
+        m.setanswers2(a2);
+       
+
+       
+        OrxonoxOverlay::showOverlay("Dialogue");
+
+        return false;
+    }
+
+    void NextQuestion::XMLEventPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(NextQuestion, XMLEventPort, xmlelement, mode);
+
+        XMLPortEventSink(NextQuestion, BaseObject, "execute", execute, xmlelement, mode); 
+    }
+
+
+	void NextQuestion::setanswers1(std::string a1){
+		this->a1=a1;
+				}
+
+	void NextQuestion::setanswers2(std::string a2){
+		this->a2=a2;
+				}
+
+	
+
+	std::string NextQuestion::getanswers1(void){
+		return a1;
+	}
+
+	std::string NextQuestion::getanswers2(void){
+		return a2;
+	}
+
+	
+
+
+
+
+}
Index: code/branches/HUD_HS16/src/modules/dialogue/NextQuestion.h
===================================================================
--- code/branches/HUD_HS16/src/modules/dialogue/NextQuestion.h	(revision 11502)
+++ code/branches/HUD_HS16/src/modules/dialogue/NextQuestion.h	(revision 11502)
@@ -0,0 +1,61 @@
+#ifndef _NextQuestion_H__
+#define _NextQuestion_H__
+
+
+
+#include <string>
+#include "core/class/Identifier.h"
+#include "OrxonoxPrereqs.h"
+#include "core/XMLPort.h"
+#include "core/EventIncludes.h"
+#include "DialoguePrereqs.h"
+
+
+namespace orxonox{
+	class _OrxonoxExport NextQuestion : public BaseObject
+	{
+		
+		//tolua_begin
+		public:
+
+		NextQuestion (Context* context); // tolua_export
+		
+
+		void setquestion(std::string question);
+		std::string getquestion(void);
+
+		void setanswers1(std::string a1);
+		void setanswers2(std::string a2);
+		std::string getanswers1(void);
+		std::string getanswers2(void);
+
+		
+		
+
+		//XMLEventPort for Event that first triggers the Dialogue
+		virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode);
+
+		//XMLPort for setting questions and answers and the vector possibleQuestions
+		virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+		bool addposQuestion(NextQuestion* nq);
+		const NextQuestion* getposQuestion(unsigned int index) const;
+
+		//Sets very first currentQuestion in the DialogueManager when the event is triggered
+		bool execute(bool bTriggered, BaseObject* trigger);
+
+		std::vector<NextQuestion*> possibleQuestions;
+	
+	private:
+		std::string a1;
+		std::string a2;
+	
+
+
+		std::string question;
+		DialogueManager* m;
+
+	};
+	
+}
+#endif
Index: code/branches/HUD_HS16/src/modules/dodgerace/DodgeRace.cc
===================================================================
--- code/branches/HUD_HS16/src/modules/dodgerace/DodgeRace.cc	(revision 11501)
+++ code/branches/HUD_HS16/src/modules/dodgerace/DodgeRace.cc	(revision 11502)
@@ -36,4 +36,5 @@
 #include "DodgeRaceCube.h"
 #include "core/CoreIncludes.h"
+#include "Highscore.h"
 
 namespace orxonox
@@ -224,4 +225,10 @@
         // It will misteriously crash the game!
         // Instead startMainMenu, this won't crash.
+        if (Highscore::exists()){
+                    int score = this->getPoints();
+                    if(score > Highscore::getInstance().getHighestScoreOfGame("Dodge Race")) 
+                        Highscore::getInstance().storeHighscore("Dodge Race",score);
+
+          }
         GSLevel::startMainMenu();
     }
Index: code/branches/HUD_HS16/src/modules/gametypes/CMakeLists.txt
===================================================================
--- code/branches/HUD_HS16/src/modules/gametypes/CMakeLists.txt	(revision 11501)
+++ code/branches/HUD_HS16/src/modules/gametypes/CMakeLists.txt	(revision 11502)
@@ -3,6 +3,5 @@
   RaceCheckPoint.cc
   SpaceRaceManager.cc
-  OldSpaceRace.cc
-  OldRaceCheckPoint.cc
+
   SpaceRaceBot.cc
   SpaceRaceController.cc
Index: code/branches/HUD_HS16/src/modules/gametypes/SpaceRace.cc
===================================================================
--- code/branches/HUD_HS16/src/modules/gametypes/SpaceRace.cc	(revision 11501)
+++ code/branches/HUD_HS16/src/modules/gametypes/SpaceRace.cc	(revision 11502)
@@ -23,10 +23,42 @@
  *     Mauro Salomon
  *   Co-authors:
- *      Celine Egger
- *
- */
+ *      Celine Egger*/
+        
+
+
+
+/*
+Edited, Renewed and Revised by 
+        Berkay Berabi
+        Louis Meile
+ 
+ 
+To-do- list by Louis Meile and Berkay Berabi for future projects :
+- improve AI (SpaceRaceController): 
+i) so far bots arent able to evade obstacles. fix that!
+ii) bots should be able to use pickups
+- game crashes when bot wins the game(this is a huge problem you should work with the log file to find out what the errors are )
+- bots rotate while waiting for the countdown to end. make it stop!
+- add elements to level file to make it even more fun to play. be creative!
+*/
+
 
 #include "SpaceRace.h"
 
+#include "core/CoreIncludes.h"
+#include "chat/ChatManager.h"
+#include "util/Convert.h"
+#include "util/Math.h"
+#include "infos/Bot.h"
+#include "items/Engine.h"
+#include "controllers/HumanController.h"
+
+#include "core/CoreIncludes.h"
+#include "chat/ChatManager.h"
+#include "infos/PlayerInfo.h"
+#include "worldentities/pawns/Pawn.h"
+#include "core/config/ConfigValueIncludes.h"
+#include "infos/Bot.h"
+#include "SpaceRaceBot.h"
 #include "items/Engine.h"
 
@@ -37,4 +69,6 @@
 #include "SpaceRaceBot.h"
 #include "items/Engine.h"
+#include <vector>
+
 
 namespace orxonox
@@ -46,10 +80,87 @@
         RegisterObject(SpaceRace);
 
-        this->botclass_ = Class(SpaceRaceBot);//ClassByString("")
+        this->botclass_ = Class(SpaceRaceBot); //ClassByString("")
         this->cantMove_ = false;
         this->bTimeIsUp_ = false;
-        this->numberOfBots_ = 0; // quick fix: don't allow default-bots to enter the race
-                                 // remove this line, if a raceBot has been created.
-    }
+        this->setConfigValues();
+
+        this->numberOfBots_ = 5; // quick fix: don't allow default-bots to enter the race 
+        //we fixed the number of bots in order to have the same starting position all the time ! 
+    }
+
+  void SpaceRace::setConfigValues()
+    {
+       
+    
+    }
+
+    void SpaceRace::start()
+    {
+    // define spawn positions of the 5 bots
+
+        int startpos[15];
+        
+        startpos[0] =100;
+        startpos[1] =-40;
+        startpos[2] =0;
+        
+        startpos[3] =100;
+        startpos[4] =-40;
+        startpos[5] =100;
+        
+        startpos[6] =100;
+        startpos[7] =-40;
+        startpos[8] =-100;
+        
+        startpos[9] =0;
+        startpos[10] =-40;
+        startpos[11] =-80;
+        
+        startpos[12] =0;
+        startpos[13] =-40;
+        startpos[14] =80;
+        
+
+
+
+        Gametype::start();
+   if (true)
+        {
+            this->spawnPlayersIfRequested();
+            this->cantMove_ = true;
+            //players are unable to move while countdown is running
+            for (Engine* engine : ObjectList<Engine>()){
+                engine->setActive(false);
+                
+
+            }
+           //append spawn positions to bots
+           int a,b,c;
+            a=0;
+            b=1;
+            c=2;
+              for (SpaceRaceBot* bot : ObjectList<SpaceRaceBot>()){
+                bot->getControllableEntity()->setPosition(startpos[a],startpos[b],startpos[c]);
+               a= a+3;
+               b = b+3; 
+               c+= 3;
+            }
+
+
+        }
+
+                                                
+
+        std::string message("Use headphones to hear the countdown!");
+        this->getGametypeInfo()->sendAnnounceMessage(message);
+        ChatManager::message(message);
+
+//after 11 seconds , countdownFinished function is called to activate bots` engines
+Timer* countdownTimer = new Timer();
+        countdownTimer->setTimer(11, false, createExecutor(createFunctor(&SpaceRace::countdownFinished, this)));
+    }
+
+
+
 
     void SpaceRace::end()
@@ -63,9 +174,9 @@
         {
             message = multi_cast<std::string>(s) + "." + multi_cast<std::string>(ms) + " seconds !!\n"
-                        + "You didn't reach the check point  before the time limit. You lose!";
+                        + "You lose!";
         }
         else
         {
-            message = "You win!! You have reached the last check point after "+ multi_cast<std::string>(s)
+            message = "You win!! Final check point reached after "+ multi_cast<std::string>(s)
                         + "." + multi_cast<std::string>(ms) + " seconds.";
         }
@@ -78,31 +189,9 @@
     }
 
-    void SpaceRace::tick(float dt)
+
+void SpaceRace::tick(float dt)
     {
         SUPER(SpaceRace,tick,dt);
-
-        // spawn the players already when the countdown starts, but deactivate their engines
-        if (this->isStartCountdownRunning() && !this->cantMove_)
-        {
-            this->spawnPlayersIfRequested();
-            this->cantMove_ = true;
-
-            for (Engine* engine : ObjectList<Engine>())
-                engine->setActive(false);
-        }
-
-        // activate the engines again if the countdown ends
-        if (!this->isStartCountdownRunning() && this->cantMove_)
-        {
-            for (Engine* engine : ObjectList<Engine>())
-                engine->setActive(true);
-
-            this->cantMove_= false;
-
-            std::string message = "The match has started! Reach the check points as quickly as possible!";
-            this->getGametypeInfo()->sendAnnounceMessage(message);
-            ChatManager::message(message);
-        }
-    }
+}
 
     void SpaceRace::newCheckpointReached(RaceCheckPoint* checkpoint, PlayerInfo* player)
@@ -114,23 +203,60 @@
         int ms = this->clock_.getMilliseconds() % 1000;
 
-        const std::string& message = "Checkpoint " + multi_cast<std::string>(checkpoint->getCheckpointIndex() + 1)
-            + " reached after " + multi_cast<std::string>(s) + "." + multi_cast<std::string>(ms) + " seconds.";
+       
+    
+        const std::string& message = player->getName() + " reached the checkpoint " + multi_cast<std::string>(checkpoint->getCheckpointIndex() + 1) 
+        + "after " + multi_cast<std::string>(s) + "." + multi_cast<std::string>(ms) + " seconds.";
+ this->getGametypeInfo()->sendAnnounceMessage(message);
+        ChatManager::message(message);
+
+    }
+
+ void SpaceRace::countdownFinished()//activates the engines of all players 
+    {
+
+        std::string message("RACE STARTED ");
         this->getGametypeInfo()->sendAnnounceMessage(message);
         ChatManager::message(message);
-    }
-
+
+
+    for (Engine* engine : ObjectList<Engine>())
+                engine->setActive(true);
+
+
+    
+}
+
+ void SpaceRace::playerEntered(PlayerInfo* player)
+    {
+        Gametype::playerEntered(player);
+
+        const std::string& message = player->getName() + " entered the game";
+        ChatManager::message(message);
+    }
+
+
+ void SpaceRace::addBots(unsigned int amount) //function that add the bots to the game 
+    {
+        for (unsigned int i = 1; i <= amount; ++i){
+            this->botclass_.fabricate(this->getContext());
+        }
+    }
+
+
+//set bot configurations
     bool SpaceRace::allowPawnHit(Pawn* victim, Pawn* originator)
     {
+        return true;
+    }
+
+    bool SpaceRace::allowPawnDamage(Pawn* victim, Pawn* originator)
+    {
+        return true;
+    }
+
+    bool SpaceRace::allowPawnDeath(Pawn* victim, Pawn* originator)// false because the bots can not recognize the objects and die to early 
+                                                                    //if they can 
+    {
         return false;
     }
-
-    bool SpaceRace::allowPawnDamage(Pawn* victim, Pawn* originator)
-    {
-        return false;
-    }
-
-    bool SpaceRace::allowPawnDeath(Pawn* victim, Pawn* originator)
-    {
-        return false;
-    }
 }
Index: code/branches/HUD_HS16/src/modules/gametypes/SpaceRace.h
===================================================================
--- code/branches/HUD_HS16/src/modules/gametypes/SpaceRace.h	(revision 11501)
+++ code/branches/HUD_HS16/src/modules/gametypes/SpaceRace.h	(revision 11502)
@@ -57,9 +57,22 @@
             virtual ~SpaceRace() {}
 
+             void setConfigValues();
+
             virtual void tick(float dt) override;
+            virtual void start() override;
+            virtual void end() override;
+ virtual void countdownFinished();
+             virtual void addBots(unsigned int amount) override; //<! overwrite function in order to bypass the addbots command.
 
-            virtual void end() override;
+
+
+             virtual void playerEntered(PlayerInfo* player) override;
+
+            //virtual void newCheckpointReached();
 
             void newCheckpointReached(RaceCheckPoint* checkpoint, PlayerInfo* player);
+            
+
+
             inline RaceCheckPoint* getCheckpointReached(PlayerInfo* player)
                 { return this->checkpointReached_[player]; }
Index: code/branches/HUD_HS16/src/modules/gametypes/SpaceRaceBot.cc
===================================================================
--- code/branches/HUD_HS16/src/modules/gametypes/SpaceRaceBot.cc	(revision 11501)
+++ code/branches/HUD_HS16/src/modules/gametypes/SpaceRaceBot.cc	(revision 11502)
@@ -23,7 +23,16 @@
  *      Author: purgham
  */
+#include <vector>
 
 #include "SpaceRaceBot.h"
+#include "core/GameMode.h"
 #include "core/CoreIncludes.h"
+#include "core/config/ConfigValueIncludes.h"
+#include "gametypes/Gametype.h"
+#include "controllers/AIController.h"
+#include "gametypes/SpaceRaceController.h"
+
+
+
 
 namespace orxonox
@@ -35,4 +44,23 @@
         this->defaultController_ = Class(SpaceRaceController);// ClassByString("")
         this->createController();
+
+    }
+
+SpaceRaceBot::~SpaceRaceBot(){
+
+}
+
+void SpaceRaceBot::setConfigValues()
+    {
+        static const std::string names[] =
+        {
+            "Dr. Julius No",
+            "Berkay Berabi",
+            "Louis Meile"         
+            "Yo mama"
+        };
+        static std::vector<std::string> defaultnames(names, names + sizeof(names) / sizeof(std::string));
+
+        SetConfigValue(names_, defaultnames);
     }
 }
Index: code/branches/HUD_HS16/src/modules/gametypes/SpaceRaceBot.h
===================================================================
--- code/branches/HUD_HS16/src/modules/gametypes/SpaceRaceBot.h	(revision 11501)
+++ code/branches/HUD_HS16/src/modules/gametypes/SpaceRaceBot.h	(revision 11502)
@@ -30,4 +30,5 @@
 #include "gametypes/GametypesPrereqs.h"
 #include "gametypes/SpaceRaceController.h"
+#include <vector>
 
 
@@ -35,12 +36,26 @@
 {
 
-    /**
-
-    */
     class _GametypesExport SpaceRaceBot: public Bot
     {
         public:
-        SpaceRaceBot(Context* context);
-            virtual ~SpaceRaceBot() {}
+        	SpaceRaceBot(Context* context);
+            virtual ~SpaceRaceBot();
+    
+            void setConfigValues();
+
+
+
+ virtual inline bool isInitialized() const override
+                { return true; }
+            virtual inline float getPing() const override
+                { return 0; }
+            virtual inline float getPacketLossRatio() const override
+                { return 0; }
+
+
+  private:
+            std::vector<std::string> names_;
+
+
     };
 }
